import { Component, ViewChild } from '@angular/core';
import { EJComponents } from 'ej-angular2';
@Component({
    selector: 'ej-app',
    templateUrl: './grid.component.html',
})
export class GridComponent {
    public gridData: any;
    public filterSettings: any;
    public dataList: any;
    onClick(args) {
        var gridObj = $("#Grid").ejGrid("instance");
        var obj = $('#list').ejDropDownList("instance");
        var value = obj.getValue();

        //Post the saved (in ejDropDownlist) time
        //To retrieve the Grid objects
        $.ajax({
            type: "POST",
            crossDomain: true,
            url: "http://localhost:50498/Home/Restate",
            data: { "dropObject": value },
            success: function (data) {
                var obj = JSON.parse(data);
                gridObj.model.groupSettings.groupedColumns = obj.groupedCol;
                gridObj.model.sortSettings.sortedColumns = obj.sortedCol;
                gridObj.model.columns = obj.cols;
                gridObj.model.filterSettings.filteredColumns = obj.filteredCol;
                gridObj.columns(obj.cols);
                //gridObj.refreshContent(true);//Refresh the Grid to apply the saved settings
                //if you are using anyother Grid methods to refresh other functionlities
            },
        });
    }
    onactionComplete(e) {
        var gridObj = $("#Grid").ejGrid("instance")
        this.stateChanges(e, gridObj);
    };
    onResizeEnd(e) {
        var gridObj = $("#Grid").ejGrid("instance")
        this.stateChanges(e, gridObj);
    }
    public stateChanges(args, proxy) {
    if (args.requestType != "refresh") {
        var columns = proxy.model.columns.slice();
        if (args.type == "resizeEnd") {
            var gridCol = new ej.DataManager(columns).executeLocal(new ej.Query().where("field", ej.FilterOperators.equal, args.column.field))[0];
            var inx = columns.indexOf(gridCol);
            columns[inx].width = args.newWidth;
        }
        var state = {
            cols: columns,
            groupedCol: proxy.model.groupSettings.groupedColumns.slice(),
            sortedCol: proxy.model.sortSettings.sortedColumns.slice(),
            filteredCol: proxy.model.filterSettings.filteredColumns.slice()
        }
        var object = JSON.stringify(state);//converting object to string

        $.ajax({
            type: "POST",
            url: "http://localhost:50498/Home/Query",
            data: { "gridObj": object },//posting the grid object as string
            success: function (data, status, xhr) {
                //On Success save the data which is the time
                //based on the time saving of Grid object in the db takes place
                var TempData = [];
                var obj = $('#list').ejDropDownList("instance");

                if (!ej.isNullOrUndefined(obj.model.dataSource))
                    TempData = obj.model.dataSource;

                TempData.push({ dataTime: data, text: data });

                $('#list').ejDropDownList("destroy");
                //destroy and update the dropdownlist's dataSouce
                $('#list').ejDropDownList({ dataSource: TempData })
            },
        });
    }
}
    constructor() {
        this.filterSettings = { filterType: "menu" }
        this.gridData = new ej.DataManager({
                url: "http://js.syncfusion.com/demos/ejServices/Wcf/Northwind.svc/Orders", crossDomain: true
        });
        this.dataList = [];
        
    }
}
